/*	Application		IPC receiver-side using socket (UDP)		
	File			IPC_socket_Receiver.h
	Purpose			Demonstration of local IPC, using a blocking socket
	Author			Richard John Anthony
	Date			December 2013
*/

#pragma once

#define RECEIVE_BUFFER_SIZE 100
#define RECEIVE_PORT 8007
#define DOTTED_DECIMAL_IP_ADDRESS_SIZE 16 // 3 digits . 3 digits . 3 digits . 3 digits = 15 chars including dots

// Function declarations
bool InitialiseWindowsSocketsMechanism(void);
bool CreateReceiveSocket(void);
bool CreateReplySocket(void);
bool SetUpLocalAddressStruct(void);
IN_ADDR GetLocalHostAddressDetails(void);
bool BindToLocalAddress(void);
void ReadMessageFromReceiveBufferOrWait(void);
void ReverseBufferContents();
void SendMessage(void);
void CloseSocketAndExit(void);

// Global variables
int m_iReceivePort;
int m_iReplyPort;
SOCKET m_IPC_ReceiveSOCKET;
SOCKET m_IPC_ReplySOCKET;
char m_szRecvBuf[RECEIVE_BUFFER_SIZE];
char m_szReplyBuf[RECEIVE_BUFFER_SIZE];
char m_szSender_IP_Address[DOTTED_DECIMAL_IP_ADDRESS_SIZE];
SOCKADDR_IN m_LocalSockAddr;
SOCKADDR_IN m_SenderSockAddr; // This structure will hold the address of the sender after a message has been received
