/*	Application		IPC sender-side using socket (UDP)		
	File			IPC_socket_Sender_With_reply.h
	Purpose			Demonstration of local IPC, using a blocking socket (on the receiving side)
	Author			Richard John Anthony
	Date			December 2013
*/

#pragma once

#define SEND_BUFFER_SIZE 100
#define RECEIVE_BUFFER_SIZE 100

// Function declarations
bool InitialiseWindowsSocketsMechanism(void);
bool CreateSendSocket(void);
bool CreateReceiveReplySocket(void);
void SetUpSendAddressStructFor_LocalLoopback(void);
void SetUpLocalAddressStruct(void);
bool BindToLocalAddress(void);
bool SendMessage(void);
void ReadMessageFromReceiveBufferOrWait();
void CloseSocketAndExit(void);

// Global variables
SOCKET m_SendSOCKET;
SOCKET m_ReceiveReplySOCKET;
char m_szSendBuf[SEND_BUFFER_SIZE];
char m_szReceiveBuf[RECEIVE_BUFFER_SIZE];
int m_iSendLen;
SOCKADDR_IN m_SendSockAddr;
SOCKADDR_IN m_LocalSockAddr;
string m_UserInput;