/*	Application		Socket-based IPC threads example	
	File			Multithreaded_IPC_remote_shutdown.h
	Purpose			Demonstration of local IPC, and multithreading using a blocking socket
	Author			Richard John Anthony
	Date			February 2014
*/

#pragma once

#define SEND_BUFFER_SIZE 100
#define RECEIVE_BUFFER_SIZE 100
#define DOTTED_DECIMAL_IP_ADDRESS_SIZE 16 // 3 digits . 3 digits . 3 digits . 3 digits = 15 chars including dots

// Function declarations
bool InitialiseWindowsSocketsMechanism(void);
bool CreateSendSocket(void);
bool CreateReceiveSocket(void);

bool SetUpLocalAddressStruct(void);
IN_ADDR GetLocalHostAddressDetails(void);
bool BindToLocalAddress(void);
void SetUpSendAddressStructFor_LocalLoopback(void);
void ReceiveMessages(void);
void ReadMessageFromReceiveBufferOrWait(void);
int SendMessage(void);
void CloseSocketsAndExit(void);

// Global variables
int m_iSendPort;
int m_iReceivePort;
SOCKET m_IPC_SendSOCKET;
SOCKET m_IPC_ReceiveSOCKET;
char m_szSendBuf[SEND_BUFFER_SIZE];
char m_szRecvBuf[RECEIVE_BUFFER_SIZE];
char m_szSender_IP_Address[DOTTED_DECIMAL_IP_ADDRESS_SIZE];
SOCKADDR_IN m_LocalSockAddr;	// This structure will hold the local address (for receiving)
SOCKADDR_IN m_SendSockAddr;		// This structure will hold the address for sending to

bool m_bMainThreadRunning;		// Shared variable (across the threads)
								// Enables main thread to shutdown the (asynchronous) worker thread gracefully