/*	Application		Threads Demonstration - Threads executed synchronously with respect to main()			
	File			Threads_Join.cpp
	Purpose			Demonstrates the basic concepts of multi-threading
	Author			Richard John Anthony
	Date			January 2014
	
	Function		1. Creates three threads
					2. Runs the threads synchronously using join(). The calling thread waits for the called thread to terminate.
					3. Threads display text messages for diagnostic purposes
*/

#include <string>
#include <iostream>
#include <thread>  // using the std::thread class

using namespace std;
void Function1(string sStr);
void Function2(string sStr);
void Function3(string sStr);

void Function1(string sStr)
{
	size_t tThreadID = std::this_thread::get_id().hash();
    thread thread2(Function2 /*function the thread will perform*/, "BBBBBBBBBBBB" /*parameter for thread's function*/);
	thread2.join();			// The calling thread (thread1) waits for the called thread (thread2) to terminate
	
	for (int iCount = 0; iCount < 10; iCount++)
	{
		cout << "Function 1: " << tThreadID << " " << sStr << endl;
	}
}

void Function2(string sStr)
{
	size_t tThreadID = std::this_thread::get_id().hash();
    thread thread3(Function3 /*function the thread will perform*/, "CCCCCCCCCCCC" /*parameter for thread's function*/);
    
	thread3.join();			// The calling thread (thread2) waits for the called thread (thread3) to terminate

	for (int iCount = 0; iCount < 10; iCount++)
	{
		cout << "Function 2: " << tThreadID << " " << sStr << endl;
	}
}

void Function3(string sStr)
{
	size_t tThreadID = std::this_thread::get_id().hash();

	for (int iCount = 0; iCount < 10; iCount++)
	{
		cout << "Function 3: " << tThreadID << " " << sStr << endl;
	}
}

int main()
{
	char cWaitForUser;
    // Create a thread (thread 1)
    thread thread1(Function1 /*function the thread will perform*/, "AAAAAAAAAAAA" /*parameter for thread's function*/);

	thread1.join(); 			// The calling thread (main) waits for the called thread (thread1) to terminate   

	for (int iCount = 0; iCount < 10; iCount++)
	{
		cout << "Main" << endl;
	}

	cout << "To Exit press any key, followed by the Enter key " << endl;
	cin >> cWaitForUser;
}

