/*	Application		Timers Demonstration - Timer event handlers executed asynchronously with respect to main()			
	File			Timers_Demonstration.cpp
	Purpose			Demonstrates the basic concepts of programmable timers and event handlers
	Author			Richard John Anthony
	Date			January 2015
	
	Function		Creates three timers with periods of 1 second, 2 seconds and 3 seconds respectively
*/

#include "stdafx.h"
#include <iostream>

#using <system.dll>
using namespace std;
using namespace System;
using namespace System::Timers;

public ref class CTimers_Demonstration
{
private: 
	static Timer^ Timer1, ^ Timer2, ^ Timer3;

public:
	static void ConfigureTimers()
	{
		Timer1 = gcnew Timer(); // Create first timer
        Timer1->Elapsed += gcnew ElapsedEventHandler(CTimers_Demonstration::OnTimedEvent_Timer1); // Set event handler method for first timer
        Timer1->Interval = 1000; // Set time interval to be 1 second (1000 ms)
        Timer1->Enabled = false; // Do not start timer running yet

		Timer2 = gcnew Timer(); // Create second timer
        Timer2->Elapsed += gcnew ElapsedEventHandler(CTimers_Demonstration::OnTimedEvent_Timer2); // Set event handler method for second timer
        Timer2->Interval = 2000; // Set time interval to be 2 seconds (2000 ms)
        Timer2->Enabled = false; // Do not start timer running yet

 		Timer3 = gcnew Timer(); // Create third timer
        Timer3->Elapsed += gcnew ElapsedEventHandler(CTimers_Demonstration::OnTimedEvent_Timer3); // Set event handler method for third timer
        Timer3->Interval = 3000; // Set time interval to be 3 seconds (3000 ms)
        Timer3->Enabled = false; // Do not start timer running yet
	}
	
	static void StartTimers()
	{
		Timer1->Enabled = true;
		Timer2->Enabled = true;
		Timer3->Enabled = true;
	}

private:
	static void OnTimedEvent_Timer1( Object^ source, ElapsedEventArgs^ myEventArgs )
	{
		cout << "One second" << endl;
	}

	static void OnTimedEvent_Timer2( Object^ source, ElapsedEventArgs^ myEventArgs )
	{
		cout << "            Two seconds" << endl;
	}

	static void OnTimedEvent_Timer3( Object^ source, ElapsedEventArgs^ myEventArgs )
	{
		cout << "                         Three seconds" << endl;
	}
};

int main()
{
	CTimers_Demonstration::ConfigureTimers();	// Configure three timers with different intervals
    CTimers_Demonstration::StartTimers();		// Start all three timers 
 
	while (true)
	{
	}
}
